#ifndef GLOBALS_H
#define GLOBALS_H

#include <unistd.h>
#include <pwd.h>
#include <grp.h>
#include "types.h"
#include "dllapps.h"
#include "version.h"

#ifdef	GLOBDEF
#include "config.h"
#define	EXTERN
#define	INIT(A)	= A ;
#else
#define	EXTERN	extern
#define	INIT(A)	;
#endif	/* GLOBDEF */

/*
	General TFTP globals
*/

/* 
	configuration file derived globals 
	initialized by:	readfile.c : resetConfig()
*/
EXTERN	INT	MsgLevel 		INIT( MESSAGELEVEL )
EXTERN	INT	MaxSyslog		INIT( MAXSYSLOG )
EXTERN	CHAR*	DefaultDirectory 	INIT( NULL )
EXTERN	CHAR*	RootDirectory 		INIT( NULL )
EXTERN	uid_t	childUid		INIT( TFTPUID )
EXTERN	gid_t	childGid		INIT( TFTPGID )
EXTERN	INT	MaxInputWait		INIT( DEFTIMEOUT*60 )
EXTERN	INT	CheckOnly		INIT( 0 )
EXTERN	INT	SafeLog			INIT( 0 )
EXTERN	INT	SilentDeny		INIT( 0 )

/* 
	linked-list header
	initialized by:	readfile.c : resetConfig()
*/

EXTERN dla_t*	accessListH	INIT(NULL)  /* access list		*/	
EXTERN dlr_t*	restrictListH	INIT(NULL)  /* file restriction list	*/	
EXTERN dla_t*	threadListH	INIT(NULL)  /* active threads list	*/	
EXTERN dlf_t*	filterListH	INIT(NULL)  /* rx/tx-filter list	*/	
EXTERN dlr_t*	mapListH	INIT(NULL)  /* file name mapping list	*/
EXTERN dlp_t*	procListH	INIT(NULL)  /* subprocess list		*/

/*
	commandline derived globals
	initialized by:	readfile.c : resetConfig()
*/

EXTERN INT	CheckOnly;	/* syntax check for config file only	*/
EXTERN INT	SafeLog;	/* safe logging mode			*/
EXTERN INT	MaxSyslog;	/* max. mess. level propagated to syslog*/
EXTERN INT	SilentDeny;	/* inhibit error packets		*/
EXTERN INT	spMode;		/* single process mode (for debugging) 	*/
EXTERN INT	noResolv;	/* inhibit ip-addr. to dns-name lookup	*/
EXTERN INT	Help		INIT( 0 )	/* help request		*/
EXTERN CHAR*	ConfigFile	INIT( CONFIGFILE )
EXTERN CHAR*	DumpFile	INIT( DUMPFILE )
EXTERN CHAR*	LogFile		INIT( NULL )

/* runtime globals */

EXTERN INT	changeRoot	INIT(0)	/* change root mode		*/
EXTERN INT	isDaemon	INIT(0)	/* process is demonized		*/
EXTERN INT	isAborted	INIT(0)	/* process rundown initiated	*/
EXTERN INT	needFilter	INIT(0)	/* flags filter pipe in use	*/
EXTERN CHAR*	myName		INIT(NULL)	/* basename of argv[0]	*/
EXTERN FILE*	LogSP		INIT(NULL)	/* syslog socket	*/
EXTERN FILE*	LogFP		INIT(NULL)	/* to logfile		*/

EXTERN	INT	MsgOverride		INIT( -1 )
EXTERN	INT	MslOverride		INIT( -1 )
EXTERN	INT	tftpWaitOverride	INIT( -1 )
EXTERN	INT	DefaultDirectoryLength 	INIT( 0 )
EXTERN	INT	RootDirectoryLength 	INIT( 0 )
EXTERN	pid_t	parentPid		INIT( 0 )

#endif /* GLOBALS_H */
